/*
 * ListOfLinks Tyler 1998-1999.
 */

   public class ListOfLinks extends Object {
      EntityLink[] link;
   
      int max_number_of_links = 1;
      int number_of_links = 0;
   
   	// static stuff...
      static EntityLink[] new_array_of_links;
      static EntityLink temp_link;
   
      static Hortensius32Fast rnd = new Hortensius32Fast();
   
      static int temp, temp2, temp3, temp4, temp5, temp6;
   
      ListOfLinks() {
         link = new EntityLink[max_number_of_links];
         reset();
      }
   
   
      void reset() {
         number_of_links = 0;
      }
   
   
      final void add(EntityLink l) {
         if (number_of_links >= max_number_of_links) {
            makeMoreLinks();
         }
      
         link[number_of_links++] = l; // new EntityLink(e1, e2, l, e);
      }
   
   
      final void makeMoreLinks() {
         max_number_of_links++;
      
         new_array_of_links = new EntityLink[max_number_of_links];
      
         for (temp = 0; temp < (max_number_of_links - 1); temp++) {
            new_array_of_links[temp] = link[temp];
         }
      
         link = new_array_of_links;
      }
   
   
      final void remove(EntityLink l) {
         temp2 = getLinkNumber(l);
         removeNumberedLink(temp2);
      }
   
   
      final void removeNumberedLink(int n) {
         temp_link = link[n];
         link[n] = link[number_of_links - 1];
         link[--number_of_links] = temp_link;
      }
   
   
      final int getLinkNumber(EntityLink l) {
         for (temp = 0; temp < number_of_links; temp++) {
            if (link[temp] == l) {
               return temp;
            }
         }
      
         return -1;
      }
   
      final public boolean doesLinkExist(Entity e1, Entity e2) {
         if (number_of_links == 0) 
            return false;
         for (temp = 0; temp < number_of_links; temp++) {
            temp_link = link[temp];
            if ((temp_link.entity1 == e1) && (temp_link.entity2 == e2)) {
               return true;
            }
         
            if ((temp_link.entity1 == e2) && (temp_link.entity2 == e1)) {
               return true;
            }
         }
      
         return false;
      }
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   }
