/*
 * Shoals_Grid - Tim Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.image.ImageObserver;
   import java.awt.event.*;
   import java.applet.*;
   import java.lang.Exception;
   import java.lang.Integer;
   import java.lang.Long;
   import java.lang.Object;
   import java.util.StringTokenizer;
   import java.util.Date;
   import java.io.*;

/* To do:
 * ======
 *
 * Add a "low number of bits"
 * live/dead array - to postpone cache thrashing...?
 *
 */

   public class Shoals_Grid extends Object {
      final static int QBERT      = 0;
      final static int MARGOLUS   = 1;
      final static int SOD        = 2;
      final static int WOLF       = 3;
      final static int TRIUMPHANT = 4;
   
      static int max_non_linearity;
      static int virgin_applet;
   
      static int local_history_index;
   
   
   
   	// static int current_colour = -1;
   
      /*static int[][] in_grid;
      static int[][] out_grid;
      static int[][] tmp_grid;
      static int[][] help_grid;
   
      static int[][] grid_colour;
   
      static int[][] LUT_Table;
   
      static int[] bin256;
      static int[] sort256; */
   
   
      // static Shoals_LUT[] LUT;
   /*
      static int poly8_x[] = new int[8];
      static int poly8_y[] = new int[8];
   
      static int poly6_x[] = new int[6];
      static int poly6_y[] = new int[6];
   
      static int poly4_x[] = new int[4];
      static int poly4_y[] = new int[4];
   
      static int poly3_x[] = new int[3];
      static int poly3_y[] = new int[3];
   	*/
   
      final static int number_Shoals_LUT   = 16; // a power of two, please...
      final static int number_Shoals_LUTmo = number_Shoals_LUT - 1;
   
      static int maxstates;
      static int maxstatesmo;
      static int maxstatesmt;
   
      static int mask_value;
      static int BPC_value;
   
      // static Shoals_Canvas shoals_canvas;
   
      static int mutation_rate = 0;
      static int radiation_rate = 0;
   
      static int any_selection = 0;
   
      static int rnd_frame;
      static int coverage_counter;
   
      static int invert_edges = 1;
   
      static int mouse_pressed = 0;
   
      static int a_atgrid = 0;
   
      static int sparse = 1;
   
      static int reproduction_delay_min = 16;
      static int reproduction_delay_max = 48;
   
      static int reverse = 0;
      static int direction = 1;
   
      static int newborn;
      static int generation;
   
      // static int frame;
   
      static int from_cell;
      static int from_cell1;
   
      static int current_direction;
   
      //int edge_death;
   
      static boolean RepaintAll = true;
   
      static boolean double_buffering = false;
   
      // static boolean next_double_buffering = true;
   
      static Graphics graphics_handle;
   
      // static int ss_output;
      static int ss_north;
      static int ss_west;
      static int ss_centre;
      static int ss_east;
      static int ss_south;
      static int ss_input;
   
      static int next_result;
      static int last_result;
   
      static int next_ss;
      static int last_ss;
   
      static int cell_s;
      static int cell_n;
      static int cell_e;
      static int cell_w;
      static int cell_se;
      static int cell_ne;
      static int cell_sw;
      static int cell_nw;
      static int cell_c;
      static int cell_future;
   
      static int from_dir;
   
      static int last_temp;
      static int temp_x;
      static int temp_y;
   
      static int temp;
      static int temp2;
      static int temp3;
      static int temp4;
      static int temp5;
   
      static int tempA;
      static int temp2A;
      static int temp3A;
      static int temp4A;
   
      static int temp_delay;
   
      final static int snake_bg_colour = 0x00;
      final static int snake_eye_colour = 0x17F; // eyes
      final static int wall_colour = 0x1DA;
   
      static int oldcolour;
      static int last_colour;
   
      static int colour;
      static int default_colour;
      static int forward_colour;
      static int backward_colour;
   
      static int colourA;
      static int default_colourA;
      static int forward_colourA;
      static int backward_colourA;
   
      static int lastx = -1 ,lasty = -1;
   
      static int side = 100;
      static int inttemp;
   
      static JUR rnd = new JUR();
      static JUR temp_rnd = new JUR();
   
      static int[] snake_LUT1;
      static int[] snake_LUT2;
      static int[] snake_LUT3;
      static int[] snake_LUT4;
      static int[] snake_LUT5;
      static int[] snake_LUT6;
   
      static int smear_x = 0;
      static int smear_y = 0;
   
      static int hside;
      static int vside;
   
      static int max;
   
      static int gridsize = 4;
      static int cellsize;
   
      static int hexgridsize;
      static int hexcellsize;
   
      static int halfcellsize;
      static int halfgridsize;
   
      static int quartgridsize;
      static int quartcellsize;
   
      static int sharedgridsize;
      static int sharedcellsize;
   
      static int sharedhalfgridsize;
      static int sharedhalfcellsize;
   
      static int sharedquartgridsize;
      static int sharedquartcellsize;
   
      static int geometry = MARGOLUS;
   
      static int x_plot_gridsize;
      static int y_plot_gridsize;
   
      static int x_plot_cellsize;
      static int y_plot_cellsize;
   
      static int shared_y_plot_gridsize;
      static int shared_y_plot_cellsize;
   
      static int hsidemo;
      static int vsidemo;
   
      static int cx;
      static int cy;
   
      static int ncx;
      static int ncy;
   
      static int n0, s0, e0, w0;
      static int c0, c1;
      static int new_a0;
      static int new_a1;
      static int new_status;
      static int new_value;
      static int new_direction = 0;
   
      static int cell_number = 0;
   
      static int width;
      static int height;
   
      static int to_direction[];
      static int from_direction[];
      static int develop[];
      static int repro_direction[];
   
      static int appletsize = 512;
   
      // static ParticleManager particle_manager;
   
      // static int number_of_travellers = 0;
      //static int number_of_agents     = 32;
      //static int number_of_leaders    = 1;
   
      // static Shoals_Wibbler wibbler;
      // static Shoals_Traveller[] traveller;
      //static Shoals.entity_manager[] agent;
      //static Shoals_Leader[] leader;
   
      //static Shoals.entity_manager temp_agent;
      //static Shoals_Leader temp_leader;
   
      // static int acc_towards_leader = 16;
   
   
      // static int mask_value = 15;
   
      final static int MSGQ_SIZE = 32;
      final static int MONQ_SIZE = 512; // expands...
      final static int EDGELIST_SIZE = 1024; // !
   
      // OK, get that chunder-bucket ready ;-)
   
   
      final static int mask_act  = 0x0F;
      final static int mask_dev  = 0x70;
      final static int mask_devx = 0xF0;
   
      final static int DEAD      = 0x00;
      final static int WALL      = 0xFFFF0000;
      final static int SOURCE    = 0xFFFF00FF;
      // final static int SINK      = 0xFFFF0000;
   
      final static int END_TOP   = 1;
      final static int DATA1     = 2;
      final static int DATA2     = 3;
      final static int END_BOT   = 4;
   
      final static int CELL_SE_E_C    = 0x01;
      final static int CELL_W_SW_C    = 0x02;
      final static int CELL_NE_NW_C   = 0x03;
      final static int CELL_SE_E      = 0x04;
      final static int CELL_W_SW      = 0x05;
      final static int CELL_NE_NW     = 0x06;
      final static int CELL_SE_SW     = 0x07;
      final static int CELL_W_NW      = 0x08;
      final static int CELL_NE_E      = 0x09;
      final static int CELL_SE_NW     = 0x0A;
      final static int CELL_W_E       = 0x0B;
      final static int CELL_NE_SW     = 0x0C;
   
      final static int DEV_SE_C       = 0x10;
      final static int DEV_W_C        = 0x20;
      final static int DEV_NE_C       = 0x30;
      final static int DEV_SE         = 0x40;
      final static int DEV_W          = 0x50;
      final static int DEV_NE         = 0x60;
      final static int DEV_HEAD       = 0x70;
   
      final static int NORTH_WEST = 1;
      final static int NORTH_EAST = 2;
      final static int SOUTH_WEST = 4;
      final static int SOUTH_EAST = 8;
      final static int EAST       = 16;
      final static int WEST       = 32;
   
   
      // start types
   
   
   // colours...
      final static int COLOUR_MAX     = 512;
   
      final static int CONTROL_WIDTH  = 192;
      final static int CONTROL_HEIGHT = 32;
   
   // display type...
      final static int HEADSANDCELLS    = 0;
      final static int CELLTYPES        = 1;
      final static int DEVELOPMENT      = 2;
      final static int SNAKELIKE        = 3;
   
      // size selection?
      final static int _SIZE_UNK      = 0;
      final static int _SIZE_LARGE    = 1;
      final static int _SIZE_SMALL    = 2;
   
      final static int _TWIST_UNK     = 0;
      final static int _TWIST_HIGH    = 1;
      final static int _TWIST_LOW     = 2;
   
      final static int _EXTENT_UNK      = 0;
      final static int _EXTENT_LARGE    = 1;
      final static int _EXTENT_THIN     = 2;
      final static int _EXTENT_LONG     = 3;
      final static int _EXTENT_LONGTHIN = 4;
   
      final static int _PATTERN_UNK = 0;
      final static int _PATTERN_ON  = 1;
      final static int _PATTERN_OFF = 2;
      final static int _PATTERN_HAL = 3;
   
      final static int _MUT_OFF    =  -1;
      final static int _MUT_VLOW   =   1;
      final static int _MUT_LOW    =   2;
      final static int _MUT_QLOW   =   3;
      final static int _MUT_MEDIUM =   4;
      final static int _MUT_QHIGH  =   6;
      final static int _MUT_HIGH   =   8;
      final static int _MUT_VHIGH  =  10;
   
   
      final static int _FRAME_1   = 0;
      final static int _FRAME_2   = 1;
      final static int _FRAME_4   = 3;
      final static int _FRAME_8   = 7;
      final static int _FRAME_16  = 15;
      final static int _FRAME_32  = 31;
   
      // colours
      final static Color WorldColour    = Color.black;
      final static Color GridColour     = Color.black;
      final static Color PageColour     = new Color(0xF0,0xE8,0xFF);
      final static Color agent_colour = Color.white;
      final static Color bg_colour = Color.black;
   
   	// static Color CellColour     = Color.white;
   
      // static Color COLOUR_RIPE    = Color.red;
   
   
      static Color[] colours;
   
      static int display_type    = HEADSANDCELLS;
   
      // static int size_sel        = _SIZE_UNK;
      // static int twist_sel       = _TWIST_UNK;
      // static int extent_sel      = _EXTENT_UNK;
      // static int pattern_sel     = _PATTERN_UNK;
      // static int start_type      = 0;
   
      // static int initial_activity_type = INACTIVE; // RIPE! ;-)
   
      static int LUT_NUMBER = 16;
   
      public static void initialise(int resolutionx, int resolutiony) {
         int i,j;
      
        // LUT_Table = new int[16][LUT_NUMBER];
      
         mutation_rate = _MUT_OFF;
      
         set_size(resolutionx,resolutiony);
      
         colours = new Color[COLOUR_MAX];
      
         // colours[0] = new Color(64,64,64);
      
      	// colours[1] = new Color(255,255,255);
      
         for (int c = 0; c < COLOUR_MAX; c++) {
            colours[c] = new Color((c & 7) * 32,(c & 56) * 4,(c & 448) / 2);
            // colours[c] = new Color(c & 255,(64 + ((c * 3) >> 2)) & 255,(64 + ((c << 3) & 127) + (c >>> 2)) & 255);
         }
      
         //bin256 = new int[256];
         //sort256 = new int[256];
      /*
         develop = new int[16];
         develop[1] = DEV_SE_C;
         develop[2] = DEV_W_C;
         develop[3] = DEV_NE_C;
         develop[4] = DEV_SE;
         develop[5] = DEV_W;
         develop[6] = DEV_NE;
         develop[7] = DEV_SE;
         develop[8] = DEV_W;
         develop[9] = DEV_NE;
         develop[10] = DEV_SE;
         develop[11] = DEV_W;
         develop[12] = DEV_NE;
      	*/
      
         Shoals.entity_manager = new EntityManager();
         ParticleManager.initial();
         LineFragmentManager.initial();
         Shoals.entity_manager.creature_manager.initial();
      	// creature_manager = new 
         PrivateWorldManager.initial();
      }
   
   
      public static void setupnewcells() {
         // newboids();
      }
   
   
      public static void newboids() {
         Shoals.entity_manager.creature_manager.initial();
         Shoals.entity_manager.initial();
         PrivateWorldManager.initial();
      
         Ships.initial();
      }
   
   
      public static void addBoids() {
         Shoals.entity_manager.add();
      
         Ships.initial();
      }
   
   
      public static void noboids() {
         PrivateWorldManager.reset();
         Shoals.entity_manager.creature_manager.initial();
         Shoals.entity_manager.initial();
         Shoals.entity_manager.creature_manager.initial();
      
         Shoals.entity_manager.target_number_of_agents = 0;
         Shoals.entity_manager.target_number_of_leaders = 0;
         Shoals.entity_manager.changeNumber();
         Shoals.entity_manager.changeLeaderNumber();
      }
   
   
      public static void set_size(int h, int v) {
         hside = h;
         vside = v;
      
         hsidemo = h - 1;
         vsidemo = v - 1;
      }
   
   
      public static void setPlotGridSize(int h, int v, int n) {
         x_plot_gridsize = h / n;
         y_plot_gridsize = v / n;
      
         x_plot_cellsize = x_plot_gridsize - 1;
         y_plot_cellsize = y_plot_gridsize - 1;
      
         if (x_plot_cellsize < 3) 
            x_plot_cellsize++;
      
         if (y_plot_cellsize < 3) 
            y_plot_cellsize++;
      
         if (isHexagonal() != 0) {
            shared_y_plot_gridsize = (y_plot_gridsize * 3) >>> 2;
            shared_y_plot_cellsize = ((y_plot_gridsize * 3) >>> 2) - 1;
         }
         else
         {
            shared_y_plot_gridsize = y_plot_gridsize;
            shared_y_plot_cellsize = y_plot_cellsize;
         }
      }
   
   
      public static void setGridSize(int s) {
         gridsize = s;
         halfgridsize = gridsize >> 1;
         quartgridsize = gridsize >> 2;
         hexgridsize = halfgridsize + quartgridsize;
      
         cellsize = gridsize - 1;
         halfcellsize = halfgridsize - 1;
         quartcellsize = quartgridsize - 1;
         hexcellsize = hexgridsize - 1;
      
         if (isHexagonal() != 0) {
            sharedgridsize = hexgridsize;
            sharedcellsize = hexcellsize;
         
            sharedhalfgridsize = hexgridsize >>> 1;
            sharedhalfcellsize = (hexgridsize >>> 1) - 1;
         
            sharedquartgridsize = hexgridsize >>> 2;
            sharedquartcellsize = (hexgridsize >>> 2) - 1;
         }
         else
         {
            sharedgridsize = gridsize;
            sharedcellsize = cellsize;
         
            sharedhalfgridsize = halfgridsize;
            sharedhalfcellsize = halfcellsize;
         
            sharedquartgridsize = quartgridsize;
            sharedquartcellsize = quartcellsize;
         }
      
         if (gridsize < 3)
            cellsize = gridsize;
      
         if (halfgridsize < 3)
            halfcellsize++;
      
         if (sharedgridsize < 3)
            sharedcellsize = sharedgridsize;
      
         if (sharedhalfgridsize < 3)
            sharedhalfcellsize++;
      
         if (halfgridsize < 1)
            halfgridsize = 1;
      
         if (gridsize < 1)
            gridsize = 1;
      
         width = hside * gridsize;
         height = vside * gridsize;
      }
   
   
      public static void resetGrid() {
         blankGrid();
      
         RepaintAll = true;
      }
   
   
      public static void setGrid() {
      
      
         RepaintAll = true;
      }
   
   
     // don't call this...
      public static void blankGrid() {
      
      }
   
   
      final static public void calculate_grid() {
         if (double_buffering) {
            graphics_handle = Shoals_Canvas.image_handle;
            Shoals.entity_manager.bufferedUpdate();
            PrivateWorldManager.bufferedUpdate();
         
            ParticleManager.update();
            LineFragmentManager.update();
            Selection.performSelection();
         
            if (!Shoals.paused) {
               generation += direction;
            }
         }
      }
   
   
      final static public void deal_with_agents() {
         if (!double_buffering) {
            if (!Shoals.paused) {
               generation += direction;
               ParticleManager.update();
               LineFragmentManager.update();
               Selection.performSelection();
            }
         
            Shoals.entity_manager.unbufferedAgentUpdate();
         
            PrivateWorldManager.unbufferedUpdate();
         }
      }
   
   
      // the performance of this code can be improved...
      final static void process_one_edge_cell() {
        /* cell_w = safeRead(cx - 1,cy    );
         cell_e = safeRead(cx + 1,cy    );
         cell_n = safeRead(cx    ,cy - 1);
         cell_s = safeRead(cx    ,cy + 1);
      
         if ((cell_w | cell_e | cell_s | cell_n) == DEAD) {
            if (out_grid[cx    ][cy    ] != DEAD) {
               out_grid[cx    ][cy    ] = DEAD;
            }
         } 
         else
         {
            cell_c  = in_grid[cx    ][cy    ];
         
            cell_process();
         }
      	*/
      }
   
   
      final static void cell_process() {
      		/*
         if (cell_c < 0) {
            cell_future = cell_c;
         }
         else
         { // (cell_c << 2) + 
            if ((generation & 1) == 0) 
               temp = 4;
            else 
               temp = 8;
         
            max = cell_c;
            if (cell_n > max) 
               max = cell_n;
            if (cell_s > max) 
               max = cell_s;
            if (cell_e > max) 
               max = cell_e;
            if (cell_w > max) 
               max = cell_w;
         
            cell_future = ((((cell_c + cell_c + cell_c + max + // cell_c + max
                                   cell_w + cell_w + cell_w +
                                   cell_e + cell_e + cell_e +
                                   cell_n + cell_n + cell_n +
                                   cell_s + cell_s + cell_s
                                   )) + temp) >>> 4);
         
            //if (cell_future < 0) 
               //cell_future = 0;
         
            cell_future = cell_future & 255;
         
         }
      
         out_grid[cx][cy] = cell_future;
      	*/
      }
   
   
      final static void trivialCopy() {
      /*
         if ((hside == 1) & (vside == 1)) {
            out_grid[0][0] = in_grid[0][0];
         }
         else
         {
            if (vside == 1) {
               for (cx = 0; cx < hside; cx++) {
                  out_grid[cx][0] = in_grid[cx][0];
               }
            }
            else
            {
               if (hside == 1) {
                  for (cy = 0; cy < vside; cy++) {
                     out_grid[0][cy] = in_grid[0][cy];
                  }
               }
               else {
                  for (cx = 0; cx < hside; cx++) {
                     for (cy = 0; cy < vside; cy++) {
                        out_grid[cx][cy] = in_grid[cy][cy];
                     }
                  }
               }
            }
         }
      	*/
      }
   
   
      final static void simpleCopy() {
      
      }
   
   
      final static int safeRead(int x, int y) {
      
         return 0;
      
      
      }
   
   
      final static void swap_grids() {
      
      }
   
   
      final static void do_any_mutation() {
      }
   
   
      final static void do_any_radiation() {      
      }
   
   
      final public static void completelyClearGid(Graphics g) {
         int width = hside * gridsize;
      
         graphics_handle.setColor(GridColour);
         graphics_handle.fillRect(0,0,width + 1,width + 1);
      }
   
   
      static void setUpColour() {
         if (colour != last_colour) {
            quicklySetUpColour();
         }
      }
   
   
      static void quicklySetUpColour() {
         graphics_handle.setColor(colours[colour]);
         last_colour = colour;
      }
   
   
      final public static void redraw_changed(Graphics g) {
         graphics_handle = g;
      
         if (RepaintAll) {
            graphics_handle.clearRect(0,0,9999,9999);
         
            graphics_handle.setColor(Color.cyan);
            temp = ((Shoals_Canvas.gsy * (Shoals.entity_manager.piston + 50)) / 1050) + 2;
         
            //graphics_handle.drawRect(0,temp + 4,Shoals_Canvas.gsx - 1,Shoals_Canvas.gsy - 1 - temp);
            graphics_handle.drawRect((3 * Shoals_Canvas.gsx) >> 3,temp + 4,Shoals_Canvas.gsx >> 2,Shoals_Canvas.gsy - 1 - temp);
            graphics_handle.setColor(Color.green);
            graphics_handle.drawRect(0,temp,Shoals_Canvas.gsx - 1,4);
         
            if (virgin_applet > 0) {
               virgin_applet--;
            }
            else
            {
               RepaintAll = false;
            }
         
            // RepaintAll = false;
         
            // debug("CLEARED");
         }
      
      // Shoals_Grid.
      
         //for (from_dir = 0; from_dir <= Shoals.frame_frequency; from_dir++) {
         deal_with_agents();
         //}
      }
   
   
      final public static int getCoveragePercentage() {
         temp = coverage_counter * 101 / (hside * vside);
         if (temp > 99)
            temp = 100;
      
         return temp;
      }
   
   
      final public static void invertAll() {
         // for (cx = 0; cx < number_Shoals_LUT; cx++) {
         //    LUT[cx].invert();
         // }
      }
   
   
      final public static int isHexagonal() {
         return 0;
      }	
   
   
      public static int getMaskValue() {
         mask_value = (1 << getBPCValue()) - 1;
      
         return mask_value;
      }
   
   
      public static int getBPCValue() {
         switch (Shoals_Grid.geometry) {
            case Shoals_Grid.WOLF:
               BPC_value = 1;
            
               break;
         
            case Shoals_Grid.MARGOLUS:
               BPC_value = 4;
            
               break;
         }
      
         return BPC_value;
      }
   
   
      public static int randomCell() {
         // do {
         temp = rnd.nextInt() & 255;
         // } while ((temp & mask_act) >= 0x05);
      
         return temp;
      }
   
   
      final static void colourZero() {
         if (Shoals_Grid.last_colour != 0) {
            Shoals_Grid.colour = 0;
            Shoals_Grid.quicklySetUpColour();
         }
      }
   
   
      final static void colourRed() {
         if (Shoals_Grid.last_colour != 7) {
            Shoals_Grid.colour = 7;
            Shoals_Grid.quicklySetUpColour();
         }
      }
   
   
      final static void debug(String o) {
      
         System.out.println(o);
      }
   
   }

