//
// TTAppletFrame - Tim Tyler 1998-1999.
//

   import java.applet.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.io.*;

   class TTAppletFrame extends Frame implements ActionListener {
      Applet applet;
      final static String QUIT = "Quit";
   	// final static String SAVEIMAGEAS = "Save image as...";
      final static String SAVEDATAAS = "Save objects as...";
      final static String LOADDATA = "Load objects...";
      final static String ADDDATA = "Add objects...";
      final static String SAVECONDENSED = "Save squeezed objects as...";
   
      public TTAppletFrame(String title, Applet app, int width, int height) {
         super(title);
         applet = app;
         MenuBar menubar = new MenuBar();
         Menu file = new Menu("File",true);
         menubar.add(file);
      
         file.add(ADDDATA);
         file.add(LOADDATA);
         file.add(SAVEDATAAS);
         file.add(SAVECONDENSED);
         file.add(QUIT);
      
         setMenuBar(menubar);
         file.addActionListener(this);
      
         add("Center",applet);
         setSize(new Dimension(width,height));
      
         show();
      
         applet.init();
         applet.start();
      
         addWindowListener(
                             new WindowAdapter() {
                                public void windowClosing(WindowEvent e) {
                                   System.exit(0);
                                }// applet? no.
                             
                                public void windowDeiconified(WindowEvent e) {
                                       //applet.start();
                                }
                             
                                public void windowIconified(WindowEvent e) {
                                       //applet.stop();
                                }
                             
                             });
      }
   
   
      public void actionPerformed(ActionEvent e) {
         String arg = e.getActionCommand();
      
         if (arg == QUIT) {
            applet.stop();
            applet = null;
            System.exit(0);
         }
      
         if (arg == SAVEDATAAS) {
            Shoals.output_linefeeds = true;
            // System.out.println("DONE DataDump!");
            FileDialog fd = new FileDialog((Frame)this, "Save objects as", FileDialog.SAVE);
            // fd.setFile("tempfile.dat");
            fd.setFilenameFilter(
                                   new FilenameFilter() {
                                      public boolean accept(File dir, String name) {
                                       // return false;
                                         System.out.println("Done DataDump!" + name);
                                         return !(name.endsWith(".dat"));
                                      }
                                   }
                                );
            fd.show();
            String returnedstring = fd.getFile();
            if (!returnedstring.equals("")) {
               Shoals_Output.dataDump(returnedstring);
            }
         }
      
         if (arg == SAVECONDENSED) {
            Shoals.output_linefeeds = false;
            FileDialog fd = new FileDialog((Frame)this, "Save objects as", FileDialog.SAVE);
            fd.setFilenameFilter(
                                   new FilenameFilter() {
                                      public boolean accept(File dir, String name) {
                                       // return false;
                                         System.out.println("Done DataDump!" + name);
                                         return !(name.endsWith(".dat"));
                                      }
                                   }
                                );
            fd.show();
            String returnedstring = fd.getFile();
            if (!returnedstring.equals("")) {
               Shoals_Output.dataDump(returnedstring);
            }
         }
      
      
         if (arg == ADDDATA) {
            FileDialog fd = new FileDialog((Frame)this, "Load objects", FileDialog.LOAD);
            fd.setFilenameFilter(
                                   new FilenameFilter() {
                                      public boolean accept(File dir, String name) {
                                      
                                         return !(name.endsWith(".dat"));
                                      }
                                   }
                                );
            fd.show();
         
            String returnedstring = fd.getFile();
            if (!returnedstring.equals("")) {
               Shoals_Input.addFile(returnedstring);
            }
         }
      
         if (arg == LOADDATA) {
            // System.out.println("DONE DataDump!");
            FileDialog fd = new FileDialog((Frame)this, "Load objects", FileDialog.LOAD);
            // fd.setFile("tempfile.dat");
            fd.setFilenameFilter(
                                   new FilenameFilter() {
                                      public boolean accept(File dir, String name) {
                                         return !(name.endsWith(".dat"));
                                      }
                                   }
                                );
            fd.show();
         
            String returnedstring = fd.getFile();
            if (!returnedstring.equals("")) {
               Shoals_Input.loadFile(returnedstring);
            }
         }
      }
   
   }
